(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.rek = factory());
})(this, (function () { 'use strict';

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor);
    }
  }
  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    Object.defineProperty(Constructor, "prototype", {
      writable: false
    });
    return Constructor;
  }
  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    Object.defineProperty(subClass, "prototype", {
      writable: false
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }
  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }
  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };
    return _setPrototypeOf(o, p);
  }
  function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;
    try {
      Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }
  function _construct(Parent, args, Class) {
    if (_isNativeReflectConstruct()) {
      _construct = Reflect.construct.bind();
    } else {
      _construct = function _construct(Parent, args, Class) {
        var a = [null];
        a.push.apply(a, args);
        var Constructor = Function.bind.apply(Parent, a);
        var instance = new Constructor();
        if (Class) _setPrototypeOf(instance, Class.prototype);
        return instance;
      };
    }
    return _construct.apply(null, arguments);
  }
  function _isNativeFunction(fn) {
    try {
      return Function.toString.call(fn).indexOf("[native code]") !== -1;
    } catch (e) {
      return typeof fn === "function";
    }
  }
  function _wrapNativeSuper(Class) {
    var _cache = typeof Map === "function" ? new Map() : undefined;
    _wrapNativeSuper = function _wrapNativeSuper(Class) {
      if (Class === null || !_isNativeFunction(Class)) return Class;
      if (typeof Class !== "function") {
        throw new TypeError("Super expression must either be null or a function");
      }
      if (typeof _cache !== "undefined") {
        if (_cache.has(Class)) return _cache.get(Class);
        _cache.set(Class, Wrapper);
      }
      function Wrapper() {
        return _construct(Class, arguments, _getPrototypeOf(this).constructor);
      }
      Wrapper.prototype = Object.create(Class.prototype, {
        constructor: {
          value: Wrapper,
          enumerable: false,
          writable: true,
          configurable: true
        }
      });
      return _setPrototypeOf(Wrapper, Class);
    };
    return _wrapNativeSuper(Class);
  }
  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
  }
  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    } else if (call !== void 0) {
      throw new TypeError("Derived constructors may only return object or undefined");
    }
    return _assertThisInitialized(self);
  }
  function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();
    return function _createSuperInternal() {
      var Super = _getPrototypeOf(Derived),
        result;
      if (hasNativeReflectConstruct) {
        var NewTarget = _getPrototypeOf(this).constructor;
        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }
      return _possibleConstructorReturn(this, result);
    };
  }
  function _toPrimitive(input, hint) {
    if (typeof input !== "object" || input === null) return input;
    var prim = input[Symbol.toPrimitive];
    if (prim !== undefined) {
      var res = prim.call(input, hint || "default");
      if (typeof res !== "object") return res;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (hint === "string" ? String : Number)(input);
  }
  function _toPropertyKey(arg) {
    var key = _toPrimitive(arg, "string");
    return typeof key === "symbol" ? key : String(key);
  }

  var FetchError = function (_Error) {
    _inherits(FetchError, _Error);
    var _super = _createSuper(FetchError);
    function FetchError(response, body) {
      var _this;
      _classCallCheck(this, FetchError);
      _this = _super.call(this, response.statusText);
      _this.name = 'FetchError';
      _this.status = response.status;
      _this.response = response;
      _this.body = body;
      return _this;
    }
    return _createClass(FetchError);
  }(_wrapNativeSuper(Error));

  var requestMethods = ['delete', 'get', 'head'];
  var dataMethods = ['patch', 'post', 'put'];
  var responseTypes = {
    arrayBuffer: '*/*',
    blob: '*/*',
    formData: 'multipart/form-data',
    json: 'application/json',
    text: 'text/*'
  };
  function factory(defaults) {
    function rek(url, options) {
      if (typeof options === 'string') options = {
        response: options
      };
      options = Object.assign({}, defaults, options);
      if (options.baseUrl) {
        url = new URL(url, options.baseUrl).href;
      }
      if (options.searchParams) {
        url = url.split('?')[0] + '?' + new URLSearchParams(options.searchParams);
      }
      options.headers = new options.Headers(Object.assign({}, defaults.headers, options.headers));
      var _options = options,
        body = _options.body,
        headers = _options.headers,
        response = _options.response,
        fetch = _options.fetch;
      if (body && typeof body === 'object') {
        if (typeof body.append === 'function') {
          headers.delete('content-type');
        } else if (typeof (body.getReader || body.stream) !== 'function' && (typeof body.byteLength !== 'number' || typeof (body.slice || body.getInt8) !== 'function')) {
          options.body = JSON.stringify(body);
          headers.set('content-type', 'application/json');
        }
      }
      var onFullfilled = response && (typeof response === 'function' ? response : (headers.set('accept', responseTypes[response]), function (res) {
        return res.status === 204 ? null : res[response]();
      }));
      var res = fetch(url, options).then(function (res) {
        if (res.ok) return res;
        return res.text().then(function (text) {
          try {
            return JSON.parse(text);
          } catch (_unused) {
            return text || null;
          }
        }).catch(function () {
          return null;
        }).then(function (body) {
          throw new FetchError(res, body);
        });
      });
      return res.then(onFullfilled);
    }
    requestMethods.forEach(function (method) {
      rek[method] = function (url, options) {
        return rek(url, Object.assign({}, options, {
          method: method.toUpperCase()
        }));
      };
    });
    dataMethods.forEach(function (method) {
      rek[method] = function (url, body, options) {
        return rek(url, Object.assign({}, options, {
          body: body,
          method: method.toUpperCase()
        }));
      };
    });
    rek.extend = function (newDefaults) {
      return factory(Object.assign({}, defaults, newDefaults, {
        headers: Object.assign({}, defaults.headers, newDefaults.headers)
      }));
    };
    return rek;
  }

  var native = factory({
    credentials: 'same-origin',
    response: 'json',
    fetch: fetch,
    Headers: Headers
  });

  return native;

}));
//# sourceMappingURL=rek.umd.es5.js.map
